#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N		10				/* N */
#define EPS		pow(10.0, -8.0)	/* epsilon̐ݒ */
#define KMAX	100

/* s̓ */
void input_matrix(double **a, char c, FILE* fin, FILE* fout);
/* xNg̓ */
void input_vector(double *b, char c, FILE* fin, FILE* fout);
/* s̗̈m */
double **dmatrix(int nr1, int nr2, int nl1, int nl2);
/* s̗̈@ */
void free_dmatrix(double** a, int nr1, int nr2, int nl1, int nl2);
/* xNg̈̊m */
double* dvector(int i, int j);
/* xNg̗̈@ */
void free_dvector(double* a, int i);
/* r֐ */
int double_comp(const void *s1, const void *s2);
/* őlm̌vZ@a[m...n] */
double vector_norm_max(double *a, int m, int n);
/* Rr@ */
double* jacobi_lin(double** a, double* b, double* x);

/* s̓ */
void input_matrix(double **a, char c, FILE* fin, FILE* fout) {
	int i, j;
	fprintf(fout, "s%c͎̒ʂł\n", c);
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= N; ++j) {
			fscanf_s(fin, "%lf", &(a[i][j]));
			fprintf(fout, "%5.2f\t", a[i][j]);
		}
		fprintf(fout, "\n");
	}
}

/* xNg̓ */
void input_vector(double *b, char c, FILE* fin, FILE* fout) {
	int i;
	fprintf(fout, "xNg%c͎̒ʂł\n", c);
	for (i = 1; i <= N; ++i) {
		fscanf_s(fin, "%lf", &(b[i]));
		fprintf(fout, "%5.2f\t", b[i]);
		fprintf(fout, "\n");
	}
}

/* s̗̈m */
double** dmatrix(int nr1, int nr2, int nl1, int nl2)
{
	int i, nrow, ncol;
	double** a;

	nrow = nr2 - nr1 + 1; /* s̐ */
	ncol = nl2 - nl1 + 1; /* ̐ */

	/* s̊m */
	if ((a = (double **) malloc(nrow * sizeof(double*))) == NULL)
	{
		printf("mۂł܂isaj\n");
		exit(1);
	}
	a = a - nr1; /* s炷 */

	/* ̊m */
	for (i = nr1; i <= nr2; ++i) a[i] = (double *)malloc(ncol * sizeof(double)); 
	/* for (i = 0; i < nrow; ++i) a[i] = (double *)malloc(ncol * sizeof(double)); */
	for (i = nr1; i <= nr2; i++) a[i] = a[i] - nl1; 

	return a;
}

/* s̗̈@ */
void free_dmatrix(double** a, int nr1, int nr2, int nl1, int nl2) 
{
	int i;

	/* ̉@@*/
	for (i = nr1; i <= nr2; ++i) free((void*)(a[i] + nl1)); 
	free((void*)(a + nr1)); 
}


/* xNg̈̊m */
double* dvector(int i, int j) /* a[i]`a[j]̗̈m */
{
	double* a;

	if ((a = (double *) malloc(((j - i + 1) * sizeof(double)))) == NULL)
	{
		printf("mۂł܂ifrom dvectorj\n");
		exit(1);
	}

	return (a - i);
}

/* xNg̗̈@ */
void free_dvector(double* a, int i)
{
	free((void*)(a + i)); /* (void *)^ւ̃LXgKv@*/
}

/* r֐ */
int double_comp(const void *s1, const void *s2)
{
	const double a1 = *((double*)s1); /* (double*)փLXg */
	const double a2 = *((double*)s2); /* (double*)փLXg */

	if (a1 < a2)
	{
		return -1;
	}
	else if (a1 == a2)
	{
		return 0;
	}
	else
	{
		return 1;
	}
}

/* őlm̌vZ@a[m...n] */
double vector_norm_max(double *a, int m, int n)
{
	int i, tmp;
	tmp = n - m - 1; /* Svf̌vZ */

	for (i = m; i <= n; i++) a[i] = fabs(a[i]);

	/* בւF擪AhXmĂ邱ɒ */
	qsort(a + m, tmp, sizeof(a[0]), double_comp);

	return a[n];
}

int main(void)
{
	FILE* fin, * fout;
	double** a, * b, * x;
	int i;
	errno_t error;

	/* s񂨂уxNg̗̈m */
	a = dmatrix(1, N, 1, N); /* s a[l. . .N] [1. . .N] */
	b = dvector(1, N); /* b[l...N] */
	x = dvector(1, N); /* x[l...N] */

	/* t@C̃I[v */
	
	error = fopen_s(&fin, "input_sp.dat", "r");
	if ( error )
	{
		printf("t@C܂ : input_sp.dat \n");
		exit(1);
	}

	error = fopen_s(&fout, "output_sp.dat", "w");
	if ( error )
	{
		printf("t@C쐬ł܂ : output_sp.dat \n");
		exit(1);
	}

	input_matrix(a, 'A', fin, fout); /* sA̓o */
	input_vector(b, 'b', fin, fout); /* xNgb̓o */
	input_vector(x, 'x', fin, fout); /* xNgx0̓o */
	x = jacobi_lin(a, b, x);

	/* ʂ̏o */
	fprintf(fout, "Ax=b ͎̉̒ʂł\n");
	for (i = 1; i <= N; i++)
	{
		fprintf(fout, "%f\n", x[i]);
	}

	fclose(fin); fclose(fout); /* t@C̃N[Y */

	/* ̈̉@ */
	free_dmatrix(a, 1, N, 1, N); free_dvector(b, 1); free_dvector(x, 1);

	return 0;
}

/* Rr@ */
double* jacobi_lin(double** a, double* b, double* x)
{
	double eps, *xn;
	int i, j, k = 0;
	xn = dvector(1, N); /* xn[1...N] */
	/* x <- x_k, xn <- x_{k+l} */
	do
	{
		for (i = 1; i <= N; i++)
		{
			xn[i] = b[i];
			for (j = 1; j <= N; j++)
			{
				xn[i] -= a[i][j] * x[j];
			}
			xn[i] += a[i][i] * x[i];
			xn[i] /= a[i][i];
		}
		for (i = 1; i <= N; i++) x[i] = xn[i] - x[i];
		eps = vector_norm_max(x, 1, N); /* őlm̌vZ */
		for (i = 1; i <= N; i++) x[i] = xn[i]; /* lXV */
		k++;
	} while (eps > EPS && k < KMAX);
	free_dvector(xn, 1); /* ̈̉@ */
	if (k == KMAX)
	{
		printf("܂ł\n");
		exit(1);
	}
	else
	{
		printf("񐔂%dł\n", k); /*@񐔂ʂɕ\ */
		return x;
	}
}